## opm-simulators 2025.04+ds

=== CMakeLists.txt ===
###########################################################################
#                                                                         #
# Note: The bulk of the build system is located in the cmake/ directory.  #
#       This file only contains the specializations for this particular   #
#       project. Most likely you are interested in editing one of these   #
#       files instead:                                                    #
#                                                                         #
#       dune.module                              Name and version number  #
#       CMakeLists_files.cmake                   Path of source files     #
#       cmake/Modules/${project}-prereqs.cmake   Dependencies             #
#                                                                         #
###########################################################################

# Mandatory call to project

cmake_minimum_required (VERSION 3.10)

project(opm-simulators C CXX)


option(SIBLING_SEARCH "Search for other modules in sibling directories?" ON)
set( USE_OPENMP_DEFAULT OFF ) # Use of OpenMP is considered experimental
option(BUILD_FLOW "Build the production oriented flow simulator?" ON)
option(BUILD_FLOW_VARIANTS "Build the variants for flow by default?" OFF)
option(BUILD_FLOW_FLOAT_VARIANTS "Build the variants for flow using float?" OFF)
option(BUILD_FLOW_POLY_GRID "Build flow blackoil with polyhedral grid" OFF)
option(OPM_ENABLE_PYTHON "Enable python bindings?" OFF)
option(OPM_ENABLE_PYTHON_TESTS "Enable tests for the python bindings?" ON)
option(OPM_INSTALL_PYTHON "Install python bindings?" ON)
option(USE_CHOW_PATEL_ILU "Use the iterative ILU by Chow and Patel?" OFF)
option(USE_CHOW_PATEL_ILU_GPU "Run iterative ILU decomposition on GPU? Requires USE_CHOW_PATEL_ILU" OFF)
option(USE_CHOW_PATEL_ILU_GPU_PARALLEL "Try to use more parallelism on the GPU during the iterative ILU decomposition? Requires USE_CHOW_PATEL_ILU_GPU" OFF)
option(BUILD_FLOW_ALU_GRID "Build flow blackoil with alu grid" OFF)
option(USE_DAMARIS_LIB "Use the Damaris library for asynchronous I/O?" OFF)
option(USE_GPU_BRIDGE "Enable the GPU bridge (GPU/AMGCL solvers)" ON)
option(USE_TRACY_PROFILER "Enable tracy profiling" OFF)
option(CONVERT_CUDA_TO_HIP "Convert CUDA code to HIP (to run on AMD cards)" OFF)
option(USE_AMGX "Enable AMGX support?" OFF)
option(USE_HYPRE "Use the Hypre library for linear solvers?" OFF)
set(OPM_COMPILE_COMPONENTS "2;3;4;5;6;7" CACHE STRING "The components to compile support for")
option(USE_OPENCL "Enable OpenCL support?" ON)

# Ensure OPM_COMPILE_COMPONENTS is a list of at least one element
if(OPM_COMPILE_COMPONENTS STREQUAL "")
  message(FATAL_ERROR "OPM_COMPILE_COMPONENTS must contain at least one component.")
endif()
# Check that OPM_COMPILE_COMPONENTS is a subset of 2,3,4,5,6,7
set(valid_components "2;3;4;5;6;7")
foreach(component IN LISTS OPM_COMPILE_COMPONENTS)
  list(FIND valid_components ${component} index)
  if(index EQUAL -1)
    message(FATAL_ERROR "Invalid component ${component} in OPM_COMPILE_COMPONENTS. Valid components are: ${valid_components}")
  endif()
endforeach()
# Check for duplicates in OPM_COMPILE_COMPONENTS
list(REMOVE_DUPLICATES OPM_COMPILE_COMPONENTS)
# Make a string we can use in the code
# this will be used in a template argument pack.
string(REPLACE ";" "," OPM_COMPILE_COMPONENTS_TEMPLATE_LIST "${OPM_COMPILE_COMPONENTS}")


# HIP requires cmake version 3.21
if (CONVERT_CUDA_TO_HIP AND CMAKE_VERSION VERSION_GREATER_EQUAL "3.21")
  enable_language(HIP)
  message("CUDA code will be hipified")
  set(HAVE_CUDA 1) # we still need this defined so that the preprocessor does not remove the code
  set(CUDA_FOUND ON)
  set(USE_HIP 1)
  find_package(hip REQUIRED)
  find_package(hipsparse REQUIRED)
  find_package(hipblas REQUIRED)
  link_libraries(roc::hipblas roc::hipsparse)
elseif(CONVERT_CUDA_TO_HIP)
  message("To generate HIP code for AMD GPUs run CMake with version >= 3.21")
endif()

# The following was copied from CMakeLists.txt in opm-common.
# TODO: factor out the common parts in opm-common and opm-simulator as a cmake module
if (OPM_ENABLE_PYTHON)
  # We need to be compatible with older CMake versions
  # that do not offer FindPython3
  # e.g. Ubuntu LTS 18.04 uses cmake 3.10
  if(${CMAKE_VERSION} VERSION_LESS "3.12.0")
    find_package(PythonInterp REQUIRED)
    if(PYTHON_VERSION_MAJOR LESS 3)
      message(SEND_ERROR "OPM requires version 3 of Python but only version ${PYTHON_VERSION_STRING} was found")
    endif()
    set(Python3_EXECUTABLE ${PYTHON_EXECUTABLE})
    set(Python3_LIBRARIES ${PYTHON_LIBRARIES})
    set(Python3_VERSION "${PYTHON_VERSION_STRING}")
    set(Python3_VERSION_MINOR ${PYTHON_VERSION_MINOR})
  else()
    # Be backwards compatible.
    if(PYTHON_EXECUTABLE AND NOT Python3_EXECUTABLE)
      set(Python3_EXECUTABLE ${PYTHON_EXECUTABLE})
    endif()
    if(${CMAKE_VERSION} VERSION_LESS "3.18.0")
      find_package(Python3 REQUIRED COMPONENTS Interpreter Development)
    else()
      find_package(Python3 REQUIRED COMPONENTS Interpreter Development.Module)
    endif()
  endif()
  if(Python3_VERSION_MINOR LESS 3)
    # Python native namespace packages requires python >= 3.3
    message(SEND_ERROR "OPM requires python >= 3.3 but only version ${Python3_VERSION} was found")
  endif()
  # Compatibility settings for PythonInterp and PythonLibs
  # used e.g. in FindCwrap, pybind11
  set(PYTHON_EXECUTABLE ${Python3_EXECUTABLE})
endif()

if(SIBLING_SEARCH AND NOT opm-common_DIR)
  # guess the sibling dir
  get_filename_component(_leaf_dir_name ${PROJECT_BINARY_DIR} NAME)
  get_filename_component(_parent_full_dir ${PROJECT_BINARY_DIR} DIRECTORY)
  get_filename_component(_parent_dir_name ${_parent_full_dir} NAME)
  #Try if <module-name>/<build-dir> is used
  get_filename_component(_modules_dir ${_parent_full_dir} DIRECTORY)
  if(IS_DIRECTORY ${_modules_dir}/opm-common/${_leaf_dir_name})
    set(opm-common_DIR ${_modules_dir}/opm-common/${_leaf_dir_name})
  else()
    string(REPLACE ${PROJECT_NAME} opm-common _opm_common_leaf ${_leaf_dir_name})
    if(NOT _leaf_dir_name STREQUAL _opm_common_leaf
        AND IS_DIRECTORY ${_parent_full_dir}/${_opm_common_leaf})
      # We are using build directories named <prefix><module-name><postfix>
      set(opm-common_DIR ${_parent_full_dir}/${_opm_common_leaf})
    elseif(IS_DIRECTORY ${_parent_full_dir}/opm-common)
      # All modules are in a common build dir
      set(opm-common_DIR "${_parent_full_dir}/opm-common")
    endif()
  endif()
endif()
if(opm-common_DIR AND NOT IS_DIRECTORY ${opm-common_DIR})
  message(WARNING "Value ${opm-common_DIR} passed to variable"
    " opm-common_DIR is not a directory")
endif()

find_package(opm-common REQUIRED)

include(OpmInit)
OpmSetPolicies()

if(USE_MPI)
  set(HDF5_PREFER_PARALLEL TRUE)
endif()

if(USE_GPU_BRIDGE)
  set(COMPILE_GPU_BRIDGE 1)
endif()

# not the same location as most of the other projects? this hook overrides
macro (dir_hook)
endmacro (dir_hook)

# project information is in dune.module. Read this file and set variables.
# we cannot generate dune.module since it is read by dunecontrol before
# the build starts, so it makes sense to keep the data there then.
include (OpmInit)

# Look for the opm-tests repository; if found the variable
# HAVE_OPM_TESTS will be set to true.
include(Findopm-tests)

# list of prerequisites for this particular project; this is in a
# separate file (in cmake/Modules sub-directory) because it is shared
# with the find module
include ("${project}-prereqs")

# Make sure we are using the same compiler underneath
# NVCC as for the rest. In the case that NVCC does not support
# that compiler it will error out. Unfortunately this will only
# work for CMake >= 3.8. We found no way to make FindCUDA.cmake error
# out. It seems to ignore CMAKE_NVCC_FLAGS and CMAKE. Additionally
# our way of specifying cuda source files never worked for CMake
# version < 3.8. Hence we deactivate cuda for these versions.
# We use "CMAKE_VERSION VERSION_GREATER 3.7.9" instead of
# CMAKE_VERSION VERSION_GREATER_EQUAL 3.8, because of backwards
# compatibility to cmake 3.6 and lower.
if(NOT CMAKE_DISABLE_FIND_PACKAGE_CUDA AND
    CMAKE_VERSION VERSION_GREATER 3.7.9)
  if(CMAKE_BUILD_TYPE)
    set(_flags_suffix "_${CMAKE_BUILD_TYPE}")
  endif()
  if(NOT DEFINED ENV{CUDAHOSTCXX} AND NOT DEFINED CMAKE_CUDA_HOST_COMPILER AND
      (NOT CMAKE_CUDA_FLAGS${_flags_suffix} OR NOT CMAKE_CUDA_FLAGS${_flags_suffix} MATCHES ".*-ccbin .*"))
    message(STATUS "Setting CUDA host compiler CMAKE_CUDA_HOST_COMPILER to ${CMAKE_CXX_COMPILER} to "
      "prevent incompatibilities. Note that this might report that there "
      "is not CUDA compiler if your system's CUDA compiler does not support "
      "${CMAKE_CXX_COMPILER}.")
    # check_language does not seem to care about ${CMAKE_CUDA_FLAGS} or $(CUDA_NVCC_FLAGS}.
    # Hence we set CMAKE_CUDA_HOST_COMPILER to our C++ compiler.
    # In check_language(CUDA) we will get an error if we in addition put
    # "-ccbin ${CMAKE_CXX_COMPILER}" into CMAKE_CUDA_FLAGS. It results
    # in "${NVCC} -ccbin=${CMAKE_CXX_COMPILER}   -ccbin ${CMAKE_CXX_COMPILER}"
    # which causes nvcc to abort
    set(CMAKE_CUDA_HOST_COMPILER ${CMAKE_CXX_COMPILER})
    set(ENV{CUDAHOSTCXX} ${CMAKE_CUDA_HOST_COMPILER}) # The only thing honored by check_language(CUDA)!
  endif()
  include(CheckLanguage)
  check_language(CUDA)
  if(CMAKE_CUDA_COMPILER)
    # OPTIONAL is ignored. Hence the magic above to check whether enabling CUDA works
    enable_language(CUDA OPTIONAL)
    # While the documentation says that it is deprecated, FindCUDA seems the
    # only easy way to determine the cublas and cusparse libraries.
    # Hence we call it unconditionally
    # The WellContributions kernel uses __shfl_down_sync, which was introduced in CUDA 9.0
    find_package(CUDA)
    set(CUDA_FOUND ON)
  endif()
  if(CUDA_FOUND AND CUDA_VERSION VERSION_LESS "9.0")
    set(CUDA_FOUND OFF)
    message(WARNING "Deactivating CUDA as we require version 9.0 or newer."
      " Found only CUDA version ${CUDA_VERSION}.")
  endif()
endif()

find_package(CUDAToolkit)
if(CUDA_FOUND)
  set(HAVE_CUDA 1)
  if(NOT USE_HIP) # no need to include CUDA files if we use rocm stack
    include_directories(${CUDA_INCLUDE_DIRS})
    include_directories(${CUDAToolkit_INCLUDE_DIRS})
  endif()
endif()

if (USE_OPENCL)
  find_package(OpenCL)

  if(OpenCL_FOUND)
    # the current OpenCL implementation relies on cl2.hpp, not cl.hpp
    # make sure it is available, otherwise disable OpenCL
    find_file(CL2_HPP CL/cl2.hpp HINTS ${OpenCL_INCLUDE_DIRS})
    if(CL2_HPP)
      set(HAVE_OPENCL 1)
      include_directories(${OpenCL_INCLUDE_DIRS})
      find_file(OPENCL_HPP CL/opencl.hpp HINTS ${OpenCL_INCLUDE_DIRS})
      if(OPENCL_HPP)
        set(HAVE_OPENCL_HPP 1)
      endif()
    else()
      message(WARNING " OpenCL was found, but this version of opm-simulators relies on CL/cl2.hpp, which implements OpenCL 1.0, 1.1 and 1.2.\n Deactivating OpenCL")
      set(OpenCL_FOUND OFF)
      set(OPENCL_FOUND OFF)
    endif()
    if(USE_CHOW_PATEL_ILU)
      add_compile_options(-DCHOW_PATEL=1)
      if(USE_CHOW_PATEL_ILU_GPU)
        add_compile_options(-DCHOW_PATEL_GPU=1)
        if(USE_CHOW_PATEL_ILU_GPU_PARALLEL)
          add_compile_options(-DCHOW_PATEL_GPU_PARALLEL=1)
        else()
          add_compile_options(-DCHOW_PATEL_GPU_PARALLEL=0)
        endif()
      else()
        add_compile_options(-DCHOW_PATEL_GPU=0)
        add_compile_options(-DCHOW_PATEL_GPU_PARALLEL=0)
      endif()
    endif()
  else()
    if(USE_CHOW_PATEL_ILU)
      message(FATAL_ERROR " CHOW_PATEL_ILU only works for openclSolver, but OpenCL was not found")
    endif()
  endif()
endif()

find_package(amgcl)
if(amgcl_FOUND)
  set(HAVE_AMGCL 1)
  # Linking to target angcl::amgcl drags in OpenMP and -fopenmp as a compile
  # flag. With that nvcc fails as it does not that flag.
  # Hence we set AMGCL_INCLUDE_DIRS.

=== python/requirements.txt ===
six
future
decorator
opm
numpy

=== python/simulators/CMakeLists.txt ===
set(PYTHON_OPM_SIMULATORS_PACKAGE_PATH ${PROJECT_BINARY_DIR}/python/opm/simulators)

# Set the path to the input docstrings.json file and the output .hpp file
set(PYTHON_DOCSTRINGS_FILE "${PROJECT_SOURCE_DIR}/python/docstrings_simulators.json")
set(PYTHON_DOCSTRINGS_GENERATED_HPP "${PROJECT_BINARY_DIR}/python/PyBlackOilSimulatorDoc.hpp")
#  Note: If the new find_package(Python3) is used in the top level CMakeLists.txt, the variable
#    ${PYTHON_EXECUTABLE} is set there to ${Python3_EXECUTABLE}
#
# Command to run the Python script

find_file(PYTHON_GENERATE_DOCSTRINGS_PY generate_docstring_hpp.py
  PATHS ${opm-common_DIR} ${opm-common_PYTHON_COMMON_DIR}
  PATH_SUFFIXES python NO_DEFAULT_PATH REQUIRED)

add_custom_command(
    OUTPUT ${PYTHON_DOCSTRINGS_GENERATED_HPP}
    COMMAND ${CMAKE_COMMAND} -E env PYTHONPATH=${CMAKE_SOURCE_DIR}
            ${PYTHON_EXECUTABLE} ${PYTHON_GENERATE_DOCSTRINGS_PY}
            ${PYTHON_DOCSTRINGS_FILE} ${PYTHON_DOCSTRINGS_GENERATED_HPP} PYBLACKOILSIMULATORDOC_HPP "Opm::Pybind::DocStrings"
    DEPENDS ${PYTHON_DOCSTRINGS_FILE}
    COMMENT "Generating PyBlackOilSimulatorDoc.hpp from JSON file"
)
# NOTE: The variable ${PYBIND11_SYSTEM} is set in python/CMakeLists.txt
#   to the value "SYSTEM" or unset, depending on the current version of Pybind11.
#   The value is then forwarded to target_include_directories(), see
#
#  https://cmake.org/cmake/help/latest/command/target_include_directories.html
#  https://pybind11.readthedocs.io/en/stable/compiling.html
#
pybind11_add_module(simulators ${PYBIND11_SYSTEM}
  $<TARGET_OBJECTS:moduleVersion>
  Pybind11Exporter.cpp
  PyBlackOilSimulator.cpp
  ${PYTHON_DOCSTRINGS_GENERATED_HPP}  # Include the generated .hpp as a source file
  )

set_target_properties( simulators PROPERTIES LIBRARY_OUTPUT_DIRECTORY ${PYTHON_OPM_SIMULATORS_PACKAGE_PATH} )

target_link_libraries( simulators PRIVATE opmsimulators )
# Add the binary (build) directory to the include directories for the target

  # Add the build directory where the generated hpp file will be
#  to the include directories for the target
target_include_directories(simulators PRIVATE ${PROJECT_BINARY_DIR}/python)

execute_process(COMMAND ${PYTHON_EXECUTABLE} -c "
import site, sys
try:
    sys.stdout.write(site.getsitepackages()[-1])
except e:
    sys.stdout.write('')" OUTPUT_VARIABLE PYTHON_SITE_PACKAGES_PATH)

if (PYTHON_SITE_PACKAGES_PATH MATCHES ".*/dist-packages/?" AND
      CMAKE_INSTALL_PREFIX MATCHES "^/usr.*")
  # dist-packages is only used if we install below /usr and python's site packages
  # path matches dist-packages
  set(PYTHON_PACKAGE_PATH "dist-packages")
else()
  set(PYTHON_PACKAGE_PATH "site-packages")
endif()

if(OPM_ENABLE_PYTHON_TESTS)
  set(PYTHON_PATH ${PROJECT_BINARY_DIR}/python:${opm-common_DIR}/python:$ENV{PYTHONPATH})
  # NOTE: See comment in test_basic.py for the reason why we are
  #   splitting the python tests into multiple add_test() tests instead
  #   of having a single "python -m unittest" test call that will run all
  #   the tests in the "test" sub directory.
  foreach(case_name IN ITEMS basic fluidstate_variables mpi primary_variables schedule throw)
    add_test(NAME python_${case_name}
        WORKING_DIRECTORY ${PROJECT_BINARY_DIR}/python
        COMMAND ${CMAKE_COMMAND}
        -E env PYTHONPATH=${PYTHON_PATH} ${PYTHON_EXECUTABLE}
        -m unittest test/test_${case_name}.py)
  endforeach()
endif()

find_file(PYTHON_INSTALL_PY install.py
  PATHS ${opm-common_DIR} ${opm-common_PYTHON_COMMON_DIR}
  PATH_SUFFIXES python NO_DEFAULT_PATH REQUIRED)

# NOTE: instead of using file( COPY ...) which copies the files at configure time (not at build time)
#  we should add copying of the files at build time such that running "make" or "make all" will
#  update the files if they have been modified. We use the install.py script in opm-common, see also
#  CMakeLists.txt in opm-common
add_custom_target(copy_python ALL
    COMMAND ${PYTHON_EXECUTABLE} "${PYTHON_INSTALL_PY}"
        ${PROJECT_SOURCE_DIR}/python/opm ${PROJECT_BINARY_DIR}/python 0
    COMMAND ${PYTHON_EXECUTABLE} "${PYTHON_INSTALL_PY}"
        ${PROJECT_SOURCE_DIR}/python/test ${PROJECT_BINARY_DIR}/python 0
    COMMAND ${PYTHON_EXECUTABLE} "${PYTHON_INSTALL_PY}"
        ${PROJECT_SOURCE_DIR}/python/test_data ${PROJECT_BINARY_DIR}/python 0
)

file(COPY ${PROJECT_SOURCE_DIR}/python/opm/CMakeLists.txt DESTINATION ${PROJECT_BINARY_DIR}/python)
file(COPY ${PROJECT_SOURCE_DIR}/python/requirements.txt DESTINATION ${PROJECT_BINARY_DIR}/python)
file(COPY ${PROJECT_SOURCE_DIR}/python/README.md DESTINATION ${PROJECT_BINARY_DIR}/python)
file(COPY ${PROJECT_SOURCE_DIR}/python/MANIFEST.in DESTINATION ${PROJECT_BINARY_DIR}/python)
file(COPY ${PROJECT_SOURCE_DIR}/python/pyproject.toml DESTINATION ${PROJECT_BINARY_DIR}/python)


set(opm-simulators_PYTHON_PACKAGE_VERSION ${OPM_PYTHON_PACKAGE_VERSION_TAG})

# Generate versioned setup.py
configure_file(${PROJECT_SOURCE_DIR}/python/setup.py.in
                ${PROJECT_BINARY_DIR}/python/setup.py.tmp @ONLY)
file(GENERATE OUTPUT ${PROJECT_BINARY_DIR}/python/setup.py
               INPUT ${PROJECT_BINARY_DIR}/python/setup.py.tmp)

add_dependencies(simulators copy_python)

# Since the installation of Python code is nonstandard it is protected by an
# extra cmake switch, OPM_INSTALL_PYTHON. If you prefer you can still invoke
# setup.py install manually - optionally with the generated script
# setup-install.sh - and completely bypass cmake in the installation phase.
if (OPM_INSTALL_PYTHON)
  include(PyInstallPrefix)  # from opm-common
  install(TARGETS simulators DESTINATION ${DEST_PREFIX}${CMAKE_INSTALL_PREFIX}/${PYTHON_INSTALL_PREFIX}/opm)
  install(
    CODE "execute_process(
      COMMAND ${PYTHON_EXECUTABLE}
              ${PYTHON_INSTALL_PY}
              ${PROJECT_BINARY_DIR}/python/opm
              ${DEST_PREFIX}${CMAKE_INSTALL_PREFIX}/${PYTHON_INSTALL_PREFIX} 1)")
endif()

=== debian/control ===
Source: opm-simulators
Priority: optional
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Arne Morten Kvarving <arne.morten.kvarving@sintef.no>, Markus Blatt <markus@dr-blatt.de>
Build-Depends: debhelper-compat (= 13), quilt, dh-sequence-python3, bc, chrpath,
               libboost-system-dev, libboost-date-time-dev, libboost-test-dev,
               zlib1g-dev, gfortran, pkgconf, lsb-release, libtool, doxygen,
               texlive-latex-extra, texlive-latex-recommended, ghostscript,
               libopm-grid-dev (>= 2025.04~),
	       mpi-default-dev, mpi-default-bin, python3-dev, libpython3-dev,
	       pybind11-dev, libhdf5-mpi-dev
Standards-Version: 4.7.2
Section: libs
Homepage: https://opm-project.org
Vcs-Browser: https://salsa.debian.org/science-team/opm-simulators
Vcs-Git: https://salsa.debian.org/science-team/opm-simulators.git
Rules-Requires-Root: no

Package: libopm-models-dev
Architecture: all
Section: oldlibs
Depends: libopm-simulators-dev (>= 2025.04~),
         ${misc:Depends}
Description: transitional package
 This is a transitional package. It can safely be removed.

Package: libopm-simulators-dev
Section: libdevel
Architecture: amd64 arm64 armel ia64 m68k mips64el mipsel ppc64el riscv64 loong64
Multi-Arch: same
Depends: ${opm:shared-library}, ${misc:Depends}, libopm-grid-dev (>= 2025.04~),
         libboost-date-time-dev, python3-opm-common
Replaces: libopm-simulators1-dev,
          libopm-models-dev (<< 2025.04~)
Suggests: libopm-simulators-doc
Breaks: libopm-models-dev (<< 2025.04~)
Description: Parallel porous media / reservoir simulators -- development files
 The Open Porous Media (OPM) software suite provides libraries and
 tools for modeling and simulation of porous media processes, especially
 for simulating CO2 sequestration and improved and enhanced oil recovery.
 .
 opm-simulators provides a research (ebos) and a production (flow) fully
 implicit black-oil simulators, supporting one to three phases and
 supporting solvent and polymer options. It uses cell centered finite
 volume schemes with two point flux approximation and automatic
 differentiation for the discretization and uses state of the art linear
 and nonlinear solvers. It supports standard and multi segment well
 models and reading and writing file in Eclipse format, a very common
 format used in the oil reservoir simulation community.
 .
 Package provides the development files (headers and shared library links).

Package: libopm-simulators
Pre-Depends: ${misc:Pre-Depends}
Architecture: amd64 arm64 armel ia64 m68k mips64el mipsel ppc64el riscv64 loong64
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}, ${python3:Depends}
Provides: ${opm:shared-library}
Replaces: libopm-simulators1
Description: Open porous media / reservoir simulators -- library
 The Open Porous Media (OPM) software suite provides libraries and
 tools for modeling and simulation of porous media processes, especially
 for simulating CO2 sequestration and improved and enhanced oil recovery.
 .
 opm-simulators provides a research (ebos) and a production (flow) fully
 implicit black-oil simulators, supporting one to three phases and
 supporting solvent and polymer options. It uses cell centered finite
 volume schemes with two point flux approximation and automatic
 differentiation for the discretization and uses state of the art linear
 and nonlinear solvers. It supports standard and multi segment well
 models and reading and writing file in Eclipse format, a very common
 format used in the oil reservoir simulation community.
 .
 Package provides the library used by the research (ebos) and production
 (flow) fully implicit  black-oil simulators.

Package: libopm-simulators-bin
Section: science
Pre-Depends: ${misc:Pre-Depends}
Architecture: amd64 arm64 armel ia64 m68k mips64el mipsel ppc64el riscv64 loong64
Multi-Arch: foreign
Depends: ${shlibs:Depends}, ${misc:Depends}
Replaces: libopm-simulators1-bin
Recommends: libopm-grid-bin, libopm-common-bin
Description: Parallel porous media / reservoir simulators -- applications
 The Open Porous Media (OPM) software suite provides libraries and
 tools for modeling and simulation of porous media processes, especially
 for simulating CO2 sequestration and improved and enhanced oil recovery.
 .
 opm-simulators provides a research (ebos) and a production (flow) fully
 implicit black-oil simulators, supporting one to three phases and
 supporting solvent and polymer options. It uses cell centered finite
 volume schemes with two point flux approximation and automatic
 differentiation for the discretization and uses state of the art linear
 and nonlinear solvers. It supports standard and multi segment well
 models and reading and writing file in Eclipse format, a defacto
 industry standard in the oil reservoir simulation community.
 .
 Package provides the simulation programs.

Package: libopm-models-doc
Architecture: all
Section: oldlibs
Depends: libopm-simulators-doc (>= 2025.04~),
         ${misc:Depends}
Description: transitional package
 This is a transitional package. It can safely be removed.

Package: libopm-simulators-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Provides: libopm-simulators-doc
Breaks: libopm-models-doc (<< 2025.04~)
Replaces: libopm-models-doc (<< 2025.04~)
Description: Open porous media / reservoir simulators -- documentation
 The Open Porous Media (OPM) software suite provides libraries and
 tools for modeling and simulation of porous media processes, especially
 for simulating CO2 sequestration and improved and enhanced oil recovery.
 .
 opm-simulators provides a research (ebos) and a production (flow) fully
 implicit black-oil simulators, supporting one to three phases and
 supporting solvent and polymer options. It uses cell centered finite
 volume schemes with two point flux approximation and automatic
 differentiation for the discretization and uses state of the art linear
 and nonlinear solvers. It supports standard and multi segment well
 models and reading and writing file in Eclipse format, a very common
 format used in the oil reservoir simulation community.
 .
 Package provides documentation of the source code of the simulators.

Package: python3-opm-simulators
Section: python
Pre-Depends: ${misc:Pre-Depends}
Architecture: amd64 arm64 armel ia64 m68k mips64el mipsel ppc64el riscv64 loong64
#Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}, ${python3:Depends}, libopm-simulators
Recommends: python3-opm-common
Description: Python wrappers for the Open porous media / reservoir simulators
 The Open Porous Media (OPM) software suite provides libraries and
 tools for modeling and simulation of porous media processes, especially
 for simulating CO2 sequestration and improved and enhanced oil recovery.
 .
 opm-simulators provides a research (ebos) and a production (flow) fully
 implicit black-oil simulators, supporting one to three phases and
 supporting solvent and polymer options. It uses cell centered finite
 volume schemes with two point flux approximation and automatic
 differentiation for the discretization and uses state of the art linear
 and nonlinear solvers. It supports standard and multi segment well
 models and reading and writing file in Eclipse format, a very common
 format used in the oil reservoir simulation community.
 .
 Package provides Python wrappers for the simulators.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
export DEB_BUILD_MAINT_OPTIONS+=optimize=-lto

include /usr/share/dpkg/architecture.mk

OPM_DEBIAN_CMAKE_FLAGS = -DOPM_ENABLE_PYTHON=1 -DOPM_INSTALL_PYTHON=1 -DPYTHON_EXECUTABLE=/usr/bin/python3 -DOPM_INSTALL_COMPILED_PYTHON=OFF  -DOPM_ENABLE_PYTHON_TESTS=0 -DCMAKE_BUILD_RPATH_USE_ORIGIN=ON


OPM_DEBIAN_MK ?= /usr/share/opm/opm-debian.mk
ifneq ("$(wildcard $(OPM_DEBIAN_MK))","")
   include $(OPM_DEBIAN_MK)
endif
OPM_LIB_DEBIAN_MK ?= /usr/share/opm/opm-lib-debian.mk
ifneq ("$(wildcard $(OPM_LIB_DEBIAN_MK))","")
    include $(OPM_LIB_DEBIAN_MK) # for makeshlibs
endif

# require 7GB of RAM per make process. Yes, peak seems to be above 6 GB currently
need_gb_ram_per_process=7
free_ram=$(shell free -g | sed -n 2p| sed "s/ \+/ /g"| cut -d " " -f 2)
max_procs=$(shell echo "$(free_ram)/$(need_gb_ram_per_process)" | bc)
parallel_procs=$(shell if test "$(max_procs)" -lt "1"; then echo 1; else echo "$(max_procs)"; fi)


override_dh_install:
	# Manually delete runpath set by openmpi 5.0.5
	# See https://bugs.debian.org/cgi-bin/bugreport.cgi?bug=1085509
	find debian/tmp/ \( -name \*.so -o  -name \*.so.\* \) -print || true
	find debian/tmp/ \( -name \*.so -o  -name \*.so.\* \) -exec chrpath -d '{}' \; || true
	find debian/tmp/usr/bin -type f -exec chrpath -d '{}' \; || true
	dh_install

%:
	echo "ram in gb: $(free_ram), needed ram per thread: $(need_gb_ram_per_process), threads: $(parallel_procs)"
	dh $@ --max-parallel=$(parallel_procs)

=== debian/watch ===
# Compulsory line, this is a version 4 file
version=4

# PGP signature mangle, so foo.tar.gz has foo.tar.gz.sig
#opts="pgpsigurlmangle=s%$%.sig%"

# GitHub hosted projects
opts="filenamemangle=s%(?:.*?)?release/(\d\d\d\d.\d\d)/(.*)\.tar\.gz%@PACKAGE@-$1-$2.tar.gz%,oversionmangle=s/(.*)/$1+ds/,uversionmangle=s/.final//;s/.rc/~rc/,dversionmangle=s/\+(debian|dfsg|ds|deb)(\.?\d+)?$//" \
   https://github.com/OPM/@PACKAGE@/tags \
   (?:.*?)?release/(\d\d\d\d\.\d\d)/(final|rc.*)\.tar\.gz debian uupdate

# Direct Git
# opts="mode=git" http://git.example.com/opm-simulators.git \
#   refs/tags/v([\d\.]+) debian uupdate

## opm-simulators 2025.10~git20251006.d7b21ed73+ds

=== debian/changelog ===
opm-simulators (2025.10~git20251006.d7b21ed73+ds-1) experimental; urgency=medium

  * Prerelease version based on commit d7b21ed
  * Depend on OPM 2025.10

 -- Markus Blatt <markus@dr-blatt.de>  Thu, 09 Oct 2025 22:09:35 +0200

## opm-simulators 2025.10%2Bds

=== debian/control ===
--- 
+++ 
@@ -6,7 +6,7 @@
                libboost-system-dev, libboost-date-time-dev, libboost-test-dev,
                zlib1g-dev, gfortran, pkgconf, lsb-release, libtool, doxygen,
                texlive-latex-extra, texlive-latex-recommended, ghostscript,
-               libopm-grid-dev (>= 2025.04~),
+               libopm-grid-dev (>= 2025.10~),
 	       mpi-default-dev, mpi-default-bin, python3-dev, libpython3-dev,
 	       pybind11-dev, libhdf5-mpi-dev
 Standards-Version: 4.7.2
@@ -19,7 +19,7 @@
 Package: libopm-models-dev
 Architecture: all
 Section: oldlibs
-Depends: libopm-simulators-dev (>= 2025.04~),
+Depends: libopm-simulators-dev (>= 2025.10~),
          ${misc:Depends}
 Description: transitional package
  This is a transitional package. It can safely be removed.
@@ -28,7 +28,7 @@
 Section: libdevel
 Architecture: amd64 arm64 armel ia64 m68k mips64el mipsel ppc64el riscv64 loong64
 Multi-Arch: same
-Depends: ${opm:shared-library}, ${misc:Depends}, libopm-grid-dev (>= 2025.04~),
+Depends: ${opm:shared-library}, ${misc:Depends}, libopm-grid-dev (>= 2025.10~),
          libboost-date-time-dev, python3-opm-common
 Replaces: libopm-simulators1-dev,
           libopm-models-dev (<< 2025.04~)
@@ -101,7 +101,7 @@
 Package: libopm-models-doc
 Architecture: all
 Section: oldlibs
-Depends: libopm-simulators-doc (>= 2025.04~),
+Depends: libopm-simulators-doc (>= 2025.10~),
          ${misc:Depends}
 Description: transitional package
  This is a transitional package. It can safely be removed.

=== debian/rules ===
--- 
+++ 
@@ -2,7 +2,6 @@
 # -*- makefile -*-
 # Uncomment this to turn on verbose mode.
 export DH_VERBOSE=1
-export DEB_BUILD_MAINT_OPTIONS+=optimize=-lto
 
 include /usr/share/dpkg/architecture.mk

## opm-simulators 2025.10+ds

=== python/CMakeLists.txt ===
find_package(pybind11 2.2 CONFIG)

if(NOT pybind11_FOUND)
  include(DownloadPyBind11)
elseif(pybind11_VERSION VERSION_GREATER_EQUAL "2.3.0")
  if(CMAKE_VERSION VERSION_LESS 3.12)
    # SYSTEM is only support for pybind >= 2.3.0 and cmake <= 3.12.0 (Unfortunately querying the
    # version does not work. AT least we know the embedded one.
    set(PYBIND11_SYSTEM "SYSTEM")
  endif()
endif()
add_subdirectory( simulators )

=== python/opm/CMakeLists.txt ===
project(install_python_binding)

cmake_minimum_required(VERSION 3.15)

install(CODE "message(\"Dummy install\")")

=== python/simulators/CMakeLists.txt ===
set(PYTHON_OPM_SIMULATORS_PACKAGE_PATH ${PROJECT_BINARY_DIR}/python/opm/simulators)

# Set the path to the input docstrings.json file and the output .hpp files
set(PYTHON_DOCSTRINGS_FILE "${PROJECT_SOURCE_DIR}/python/docstrings_simulators.json")
set(PYTHON_DOCSTRINGS_GENERATED_HPP "${PROJECT_BINARY_DIR}/python/PyBlackOilSimulatorDoc.hpp")
set(PYTHON_GW_DOCSTRINGS_GENERATED_HPP "${PROJECT_BINARY_DIR}/python/PyGasWaterSimulatorDoc.hpp")
set(PYTHON_OP_DOCSTRINGS_GENERATED_HPP "${PROJECT_BINARY_DIR}/python/PyOnePhaseSimulatorDoc.hpp")
#  Note: If the new find_package(Python3) is used in the top level CMakeLists.txt, the variable
#    ${PYTHON_EXECUTABLE} is set there to ${Python3_EXECUTABLE}
#
# Command to run the Python script

find_file(PYTHON_GENERATE_DOCSTRINGS_PY generate_docstring_hpp.py
  PATHS ${opm-common_DIR} ${opm-common_PYTHON_COMMON_DIR}
  PATH_SUFFIXES python NO_DEFAULT_PATH REQUIRED)

add_custom_command(
    OUTPUT ${PYTHON_DOCSTRINGS_GENERATED_HPP}
    COMMAND ${CMAKE_COMMAND} -E env PYTHONPATH=${CMAKE_SOURCE_DIR}
            ${PYTHON_EXECUTABLE} ${PYTHON_GENERATE_DOCSTRINGS_PY}
            ${PYTHON_DOCSTRINGS_FILE} ${PYTHON_DOCSTRINGS_GENERATED_HPP} PYBLACKOILSIMULATORDOC_HPP "Opm::Pybind::DocStrings" "BlackOil"
    DEPENDS ${PYTHON_DOCSTRINGS_FILE}
    COMMENT "Generating PyBlackOilSimulatorDoc.hpp from JSON file"
)
add_custom_command(
    OUTPUT ${PYTHON_GW_DOCSTRINGS_GENERATED_HPP}
    COMMAND ${CMAKE_COMMAND} -E env PYTHONPATH=${CMAKE_SOURCE_DIR}
            ${PYTHON_EXECUTABLE} ${PYTHON_GENERATE_DOCSTRINGS_PY}
            ${PYTHON_DOCSTRINGS_FILE} ${PYTHON_GW_DOCSTRINGS_GENERATED_HPP} PYGASWATERSIMULATORDOC_HPP "Opm::Pybind::DocStrings" "GasWater"
    DEPENDS ${PYTHON_DOCSTRINGS_FILE}
    COMMENT "Generating PyGasWaterSimulatorDoc.hpp from JSON file"
)
add_custom_command(
    OUTPUT ${PYTHON_OP_DOCSTRINGS_GENERATED_HPP}
    COMMAND ${CMAKE_COMMAND} -E env PYTHONPATH=${CMAKE_SOURCE_DIR}
            ${PYTHON_EXECUTABLE} ${PYTHON_GENERATE_DOCSTRINGS_PY}
            ${PYTHON_DOCSTRINGS_FILE} ${PYTHON_OP_DOCSTRINGS_GENERATED_HPP} PYONEPHASESIMULATORDOC_HPP "Opm::Pybind::DocStrings" "OnePhase"
    DEPENDS ${PYTHON_DOCSTRINGS_FILE}
    COMMENT "Generating PyOnePhaseSimulatorDoc.hpp from JSON file"
)
# NOTE: The variable ${PYBIND11_SYSTEM} is set in python/CMakeLists.txt
#   to the value "SYSTEM" or unset, depending on the current version of Pybind11.
#   The value is then forwarded to target_include_directories(), see
#
#  https://cmake.org/cmake/help/latest/command/target_include_directories.html
#  https://pybind11.readthedocs.io/en/stable/compiling.html
#
pybind11_add_module(BlackOil ${PYBIND11_SYSTEM}
  $<TARGET_OBJECTS:moduleVersion>
  PyBlackOilSimulator.cpp
  ${PYTHON_DOCSTRINGS_GENERATED_HPP}  # Include the generated .hpp as a source file
)

pybind11_add_module(GasWater ${PYBIND11_SYSTEM}
  $<TARGET_OBJECTS:moduleVersion>
  PyGasWaterSimulator.cpp
  ${PYTHON_GW_DOCSTRINGS_GENERATED_HPP}  # Include the generated .hpp as a source file
  )

pybind11_add_module(OnePhase ${PYBIND11_SYSTEM}
  $<TARGET_OBJECTS:moduleVersion>
  PyOnePhaseSimulator.cpp
  ${PYTHON_OP_DOCSTRINGS_GENERATED_HPP}  # Include the generated .hpp as a source file
  )

# Create a convenience target to build all Python simulator modules
add_custom_target(python_simulator_modules
  DEPENDS BlackOil GasWater OnePhase
  COMMENT "Building all Python simulator modules (BlackOil, GasWater, etc.)"
)

find_file(PYTHON_INSTALL_PY install.py
  PATHS ${opm-common_DIR} ${opm-common_PYTHON_COMMON_DIR}
  PATH_SUFFIXES python NO_DEFAULT_PATH REQUIRED)

# NOTE: instead of using file( COPY ...) which copies the files at configure time (not at build time)
#  we should add copying of the files at build time such that running "make" or "make all" will
#  update the files if they have been modified. We use the install.py script in opm-common, see also
#  CMakeLists.txt in opm-common
add_custom_target(copy_python ALL
    COMMAND ${PYTHON_EXECUTABLE} "${PYTHON_INSTALL_PY}"
        ${PROJECT_SOURCE_DIR}/python/opm ${PROJECT_BINARY_DIR}/python 0
    COMMAND ${PYTHON_EXECUTABLE} "${PYTHON_INSTALL_PY}"
        ${PROJECT_SOURCE_DIR}/python/test ${PROJECT_BINARY_DIR}/python 0
    COMMAND ${PYTHON_EXECUTABLE} "${PYTHON_INSTALL_PY}"
        ${PROJECT_SOURCE_DIR}/python/test_data ${PROJECT_BINARY_DIR}/python 0
)

foreach(target_name IN ITEMS BlackOil GasWater OnePhase)
  set_target_properties(
    ${target_name} PROPERTIES LIBRARY_OUTPUT_DIRECTORY ${PYTHON_OPM_SIMULATORS_PACKAGE_PATH}
  )
  target_link_libraries( ${target_name} PRIVATE opmsimulators )
  # Add the binary (build) directory to the include directories for the target

    # Add the build directory where the generated hpp file will be
  #  to the include directories for the target
  target_include_directories(${target_name} PRIVATE ${PROJECT_BINARY_DIR}/python)
  add_dependencies(${target_name} copy_python)

  # Since the installation of Python code is nonstandard it is protected by an
  # extra cmake switch, OPM_INSTALL_PYTHON. If you prefer you can still invoke
  # setup.py install manually - optionally with the generated script
  # setup-install.sh - and completely bypass cmake in the installation phase.
  if (OPM_INSTALL_PYTHON)
    include(PyInstallPrefix)  # from opm-common
    install(
      TARGETS ${target_name}
      DESTINATION ${DEST_PREFIX}${CMAKE_INSTALL_PREFIX}/${PYTHON_INSTALL_PREFIX}/opm
    )
    install(
      CODE "execute_process(
        COMMAND ${PYTHON_EXECUTABLE}
                ${PYTHON_INSTALL_PY}
                ${PROJECT_BINARY_DIR}/python/opm
                ${DEST_PREFIX}${CMAKE_INSTALL_PREFIX}/${PYTHON_INSTALL_PREFIX} 1)"
    )
  endif()
endforeach()

execute_process(COMMAND ${PYTHON_EXECUTABLE} -c "
import site, sys
try:
    sys.stdout.write(site.getsitepackages()[-1])
except e:
    sys.stdout.write('')" OUTPUT_VARIABLE PYTHON_SITE_PACKAGES_PATH)

if (PYTHON_SITE_PACKAGES_PATH MATCHES ".*/dist-packages/?" AND
      CMAKE_INSTALL_PREFIX MATCHES "^/usr.*")
  # dist-packages is only used if we install below /usr and python's site packages
  # path matches dist-packages
  set(PYTHON_PACKAGE_PATH "dist-packages")
else()
  set(PYTHON_PACKAGE_PATH "site-packages")
endif()

if(OPM_ENABLE_PYTHON_TESTS)
  set(PYTHON_PATH ${PROJECT_BINARY_DIR}/python:${opm-common_DIR}/python:$ENV{PYTHONPATH})
  # NOTE: See comment in test_basic.py for the reason why we are
  #   splitting the python tests into multiple add_test() tests instead
  #   of having a single "python -m unittest" test call that will run all
  #   the tests in the "test" sub directory.
  foreach(case_name IN ITEMS basic fluidstate_variables mpi primary_variables schedule throw)
    add_test(NAME python_${case_name}
        WORKING_DIRECTORY ${PROJECT_BINARY_DIR}/python
        COMMAND ${CMAKE_COMMAND}
        -E env PYTHONPATH=${PYTHON_PATH} ${PYTHON_EXECUTABLE}
        -m unittest test/test_${case_name}.py)
  endforeach()
endif()

file(COPY ${PROJECT_SOURCE_DIR}/python/opm/CMakeLists.txt DESTINATION ${PROJECT_BINARY_DIR}/python)
file(COPY ${PROJECT_SOURCE_DIR}/python/requirements.txt DESTINATION ${PROJECT_BINARY_DIR}/python)
file(COPY ${PROJECT_SOURCE_DIR}/python/README.md DESTINATION ${PROJECT_BINARY_DIR}/python)
file(COPY ${PROJECT_SOURCE_DIR}/python/MANIFEST.in DESTINATION ${PROJECT_BINARY_DIR}/python)
file(COPY ${PROJECT_SOURCE_DIR}/python/pyproject.toml DESTINATION ${PROJECT_BINARY_DIR}/python)

set(opm-simulators_PYTHON_PACKAGE_VERSION ${OPM_PYTHON_PACKAGE_VERSION_TAG})

# Generate versioned setup.py
configure_file(${PROJECT_SOURCE_DIR}/python/setup.py.in
                ${PROJECT_BINARY_DIR}/python/setup.py.tmp @ONLY)
file(GENERATE OUTPUT ${PROJECT_BINARY_DIR}/python/setup.py
               INPUT ${PROJECT_BINARY_DIR}/python/setup.py.tmp)

=== debian/changelog ===
opm-simulators (2025.10+ds-5) unstable; urgency=medium

  * Backported patches fixing cprw tests for DUNE 2.11
  * Correct pressure index also for getQuasiImpesWeights.
  * Fix build with boost 1.90 (Closes: 1127252)

 -- Markus Blatt <markus@dr-blatt.de>  Mon, 09 Feb 2026 13:32:42 +0100

opm-simulators (2025.10+ds-4) unstable; urgency=medium

  * d/rules: Exclude failing reservoir_ncp_ecfv from test on riscv64

 -- Markus Blatt <markus@dr-blatt.de>  Sat, 13 Dec 2025 14:53:19 +0100

opm-simulators (2025.10+ds-3) unstable; urgency=medium

  * d/rules: Really deactivate LTO on riscv64
  * d/rules: Pass -gno-variable-location-views on riscv64 to reduce compile time

 -- Markus Blatt <markus@dr-blatt.de>  Tue, 09 Dec 2025 22:34:52 +0100

opm-simulators (2025.10+ds-2) unstable; urgency=medium

  * d/rules: Don't use LTO on riscv64 as it breaks tests.

 -- Markus Blatt <markus@dr-blatt.de>  Tue, 18 Nov 2025 16:30:46 +0100

opm-simulators (2025.10+ds-1) unstable; urgency=medium

  * New upstream version 2025.10+ds
  * Depend on OPM 2025.10
  * d/rules: Activate lto as this should be fixed upstream

 -- Markus Blatt <markus@dr-blatt.de>  Fri, 24 Oct 2025 17:25:46 +0200

=== debian/control ===
--- 
+++ 
@@ -2,13 +2,30 @@
 Priority: optional
 Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
 Uploaders: Arne Morten Kvarving <arne.morten.kvarving@sintef.no>, Markus Blatt <markus@dr-blatt.de>
-Build-Depends: debhelper-compat (= 13), quilt, dh-sequence-python3, bc, chrpath,
-               libboost-system-dev, libboost-date-time-dev, libboost-test-dev,
-               zlib1g-dev, gfortran, pkgconf, lsb-release, libtool, doxygen,
-               texlive-latex-extra, texlive-latex-recommended, ghostscript,
+Build-Depends: debhelper-compat (= 13),
+               quilt,
+               dh-sequence-python3,
+               bc,
+               chrpath,
+               libboost-dev,
+               libboost-date-time-dev,
+               libboost-test-dev,
+               zlib1g-dev,
+               gfortran,
+               pkgconf,
+               lsb-release,
+               libtool,
+               doxygen,
+               texlive-latex-extra,
+               texlive-latex-recommended,
+               ghostscript,
                libopm-grid-dev (>= 2025.10~),
-	       mpi-default-dev, mpi-default-bin, python3-dev, libpython3-dev,
-	       pybind11-dev, libhdf5-mpi-dev
+               mpi-default-dev,
+               mpi-default-bin,
+               python3-dev,
+               libpython3-dev,
+               pybind11-dev,
+               libhdf5-mpi-dev
 Standards-Version: 4.7.2
 Section: libs
 Homepage: https://opm-project.org

=== debian/rules ===
--- 
+++ 
@@ -7,7 +7,6 @@
 
 OPM_DEBIAN_CMAKE_FLAGS = -DOPM_ENABLE_PYTHON=1 -DOPM_INSTALL_PYTHON=1 -DPYTHON_EXECUTABLE=/usr/bin/python3 -DOPM_INSTALL_COMPILED_PYTHON=OFF  -DOPM_ENABLE_PYTHON_TESTS=0 -DCMAKE_BUILD_RPATH_USE_ORIGIN=ON
 
-
 OPM_DEBIAN_MK ?= /usr/share/opm/opm-debian.mk
 ifneq ("$(wildcard $(OPM_DEBIAN_MK))","")
    include $(OPM_DEBIAN_MK)
@@ -15,6 +14,19 @@
 OPM_LIB_DEBIAN_MK ?= /usr/share/opm/opm-lib-debian.mk
 ifneq ("$(wildcard $(OPM_LIB_DEBIAN_MK))","")
     include $(OPM_LIB_DEBIAN_MK) # for makeshlibs
+endif
+
+# We have failing tests with LTO on riscv64. Hence we deactivate it.
+ifneq (,$(filter $(DEB_HOST_ARCH), riscv64))
+    # Deactivate lto on Debian and in OPM (it will try to activate LTO if we do not set OPM_INTERPROCEDURAL_OPTIMIZATION_TYPE to NONE
+    export DEB_BUILD_MAINT_OPTIONS+=optimize=-lto
+    export OPM_DEBIAN_CMAKE_FLAGS+=-DOPM_INTERPROCEDURAL_OPTIMIZATION_TYPE=NONE
+
+    # The above is ignored. Hence exclude the buggy test from ctest
+    OPM_CTEST_OPTIONS = -E reservoir_ncp_ecfv
+
+    # Hopefully bring down build time, see https://lists.debian.org/debian-riscv/2025/09/msg00019.html
+    export DEB_CXXFLAGS_MAINT_APPEND +=-gno-variable-location-views
 endif
 
 # require 7GB of RAM per make process. Yes, peak seems to be above 6 GB currently
@@ -32,6 +44,8 @@
 	find debian/tmp/usr/bin -type f -exec chrpath -d '{}' \; || true
 	dh_install
 
+override_dh_auto_test:
+	dh_auto_test -- ARGS\+="$(OPM_CTEST_OPTIONS)"
 %:
 	echo "ram in gb: $(free_ram), needed ram per thread: $(need_gb_ram_per_process), threads: $(parallel_procs)"
 	dh $@ --max-parallel=$(parallel_procs)
